package tenet.node.l2switch;

import java.util.Collection;
import java.util.HashMap;
import java.util.PriorityQueue;

import tenet.core.Simulator;
import tenet.node.INode;
import tenet.protocol.datalink.IDataLinkLayer;
import tenet.protocol.datalink.MediumAddress;
import tenet.protocol.datalink.SEther.SimpleEthernetDatalink;
import tenet.protocol.interrupt.InterruptObject;
import tenet.protocol.interrupt.InterruptParam;
import tenet.util.pattern.serviceclient.IClient;

public class L2Switch extends InterruptObject implements INode {

	public class MACWithTimestamp implements Comparable<MACWithTimestamp> {

		public Double m_time;
		public MediumAddress m_mac;

		public MACWithTimestamp(Double m_time, MediumAddress m_mac) {
			super();
			this.m_time = m_time;
			this.m_mac = m_mac;
		}

		@Override
		public int compareTo(MACWithTimestamp arg0) {
			return m_time.compareTo(arg0.m_time);
		}

	}

	protected final static int TIMER = 0x00000001;

	/**
	 * 洢㽻ϵSimpleEthernetDatalinkϢ
	 */
	public HashMap<MediumAddress, SimpleEthernetDatalink> m_datalinks;

	/**
	 * 洢תĿĵӦĳ,MAC
	 */
	public HashMap<MediumAddress, SimpleEthernetDatalink> m_macport_map;
	
	public PriorityQueue<MACWithTimestamp> m_timeout;
	protected boolean m_state = false;

	public L2Switch() {
		super();
		wait(TIMER, 1.0); // ͨʱȴÿ봥һμʱ
		m_datalinks = new HashMap<MediumAddress, SimpleEthernetDatalink>();
		m_macport_map = new HashMap<MediumAddress, SimpleEthernetDatalink>();
		m_timeout = new PriorityQueue<MACWithTimestamp>();
	}

	@Override
	public void disable() {
		if (!m_state)
			return;
		for (IDataLinkLayer iface : m_datalinks.values())
			iface.disable();
		m_state = false;
	}

	@Override
	public void dump() {

	}

	@Override
	public void enable() {
		if (m_state)
			return;
		for (IDataLinkLayer iface : m_datalinks.values())
			iface.enable();
		m_state = true;
	}

	/**
	 * macַӦĶ㽻ϵSimpleEthernetDatalink
	 */
	public SimpleEthernetDatalink getDatalink(MediumAddress mac) {
		return m_datalinks.get(mac);
	}

	/**
	 * ö㽻ϵSimpleEthernetDatalink 
	 */
	public Collection<SimpleEthernetDatalink> getDatalinks() {
		return m_datalinks.values();
	}

	/**
	 * macлmacַӦĶ˿ϵSimpleEthernetDatalink
	 */
	public SimpleEthernetDatalink getTransmitDatalink(MediumAddress mac) {
		return m_macport_map.get(mac);
	}

	@Override
	protected void interruptHandle(int signal, InterruptParam param) {
		switch (signal) {
		case TIMER:
			// TODO ¿ʼʱʱ
			this.resetInterrupt(TIMER);
			wait(TIMER, 1.0);
			// TODO ǷҪmac¼
		}
	}

	@Override
	public boolean isEnable() {
		return m_state;
	}

	public void learnMAC(MediumAddress mac, SimpleEthernetDatalink iface) {
	    // TODO MACMACַӦSimpleEthernetDatalink
	}

	@Override
	public void registryClient(IClient client) {
		// TODO һIDatalinkLayerõ㽻
	}

	@Override
	public void unregistryClient(IClient<Object> client) {
	}

	@Override
	public void unregistryClient(Object id) {
	}
}
